<?php

class rc_custom_field_gui {

  function sanitize_name( $name ) {
    $name = sanitize_title( $name ); // taken from WP's wp-includes/functions-formatting.php
    $name = str_replace( '-', '_', $name );
    
    return $name;
  }
  
  function get_custom_fields() {
    $file = dirname( __FILE__ ) . '/conf.ini';
    if ( !file_exists( $file ) )
    	return null;
    	
    $custom_fields = parse_ini_file( $file, true );
    return $custom_fields;
  }
  
  function make_textfield( $name, $size = 25, $mymeta = '' ) {
    $title = $name;
    
    if ($mymeta > '') $name = $mymeta;
		else $name = 'rc_' . rc_custom_field_gui::sanitize_name( $name );
    
    if( isset( $_REQUEST[ 'post' ] ) ) {
      $value = get_post_meta( $_REQUEST[ 'post' ], $name );
      $value = $value[ 0 ];
    }
    
    $out = 
      '<tr>' .
      '<th scope="row">' . $title . ' </th>' .
      '<td> <input id="' . $name . '" name="' . $name . '" value="' . attribute_escape($value) . '" type="textfield" size="' . $size . '" /></td>' .
      '</tr>';
    return $out;
  }
  

  function insert_gui() {
    $fields = rc_custom_field_gui::get_custom_fields();
    
    if( $fields == null)
    	return;
    
    $out = '<input type="hidden" name="rc-custom-field-gui-verify-key" id="rc-custom-field-gui-verify-key"
			value="' . wp_create_nonce('rc-custom-field-gui') . '" />';
    $out .= '<table class="editform">';
    foreach( $fields as $title => $data ) {
      if( $data[ 'type' ] == 'textfield' ) {
		
		if ( $data[ 'mymeta' ] > '' )
			$out .= rc_custom_field_gui::make_textfield( $title, $data[ 'size' ], $data[ 'mymeta' ] );
			else 
			$out .= rc_custom_field_gui::make_textfield( $title, $data[ 'size' ] );
      }

       
    $out .= '</table><br />';
    echo $out;
  }

  function edit_meta_value( $id ) {
    global $wpdb;
        
    if( !isset( $id ) )
      $id = $_REQUEST[ 'post_ID' ];
    
    
    if( !current_user_can('edit_post', $id) ) return $id;
        
    if( !wp_verify_nonce($_REQUEST['rc-custom-field-gui-verify-key'], 'rc-custom-field-gui') )
        return $id;
    
    $fields = rc_custom_field_gui::get_custom_fields();
    
    if ( $fields == null )
    	return;
    
    foreach( $fields as $title  => $data) {
    
      if ( $data[ 'mymeta' ] > '' )
		$name = $data[ 'mymeta' ];
		else
		$name = 'rc_' . rc_custom_field_gui::sanitize_name( $title );
		
      $title = $wpdb->escape(stripslashes(trim($title)));
      
      $meta_value = stripslashes(trim($_REQUEST[ "$name" ]));
      if( isset( $meta_value ) && !empty( $meta_value ) ) {
        delete_post_meta( $id, $name );
        
        if( $data[ 'type' ] == 'textfield'  ) {
          add_post_meta( $id, $name, $meta_value );
        }      
      }
      else {
        delete_post_meta( $id, $name );
      }
    }
  }
  
}
}

?>